﻿Imports System.Runtime.InteropServices

Public Class Form1

    '.NET風DOC_INFO_1の書き方
    <StructLayout(LayoutKind.Sequential)> Public Class DOC_INFO_1
        <MarshalAs(UnmanagedType.LPStr)> Public pDocName As String
        <MarshalAs(UnmanagedType.LPStr)> Public pDataType As String
        <MarshalAs(UnmanagedType.LPStr)> Public pOutputFile As String
    End Class

    'Win32 API
    Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, ByRef phPrn As Integer, ByVal pDefault As Integer) As Boolean
    Private Declare Function StartDocPrinter Lib "winspool.drv" Alias "StartDocPrinterA" (ByVal hPrn As Integer, ByVal Level As Integer, ByVal pDocInfo As DOC_INFO_1) As Integer
    Private Declare Function StartPagePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function WritePrinter Lib "winspool.drv" (ByVal hPrn As Integer, ByVal pBuf As Byte(), ByVal cdBuf As Integer, ByRef pcWritten As Integer) As Integer
    Private Declare Function EndPagePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function EndDocPrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer

    'プリンタ参照
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If PrintDialog1.ShowDialog() = DialogResult.OK Then
            TextBox2.Text = PrintDialog1.PrinterSettings.PrinterName
        End If
    End Sub

    '終了ボタン
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        '印刷テスト

        'プリンタドライバ名称
        Dim name As String
        'プリンタハンドル
        Dim hPrinter As Integer
        'APIのリターン値
        Dim Ret As Integer
        'DOC_INFO_1（RAWデータの指定に使用）
        Dim di As New DOC_INFO_1
        '送信したバイト数
        Dim Written As Integer

        'プリンタコマンド用配列
        Dim cmd As Byte() = New Byte(16) {}

        '文字列変換（シフトJIS）
        Dim str As String
        Dim bytesData As Byte()

        'DOC_INFO_1を設定する
        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'プリンタオープン
        name = TextBox2.Text
        Ret = OpenPrinter(name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        '印字処理スタート
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'コマンド送信（初期化）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'コマンド送信（シフトJIS指定コマンド FS C 1）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)


        '文字列送信
        str = "文字列テスト ABC"

        'Shift JISとして文字列に変換
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（紙送りコマンド）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '印字処理終了
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'プリンタクローズ
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'バーコード印刷

        'プリンタドライバ名称
        Dim name As String
        'プリンタハンドル
        Dim hPrinter As Integer
        'APIのリターン値
        Dim Ret As Integer
        'DOC_INFO_1（RAWデータの指定に使用）
        Dim di As New DOC_INFO_1
        '送信したバイト数
        Dim Written As Integer

        'プリンタコマンド用配列
        Dim cmd As Byte() = New Byte(16) {}

        '文字列変換（シフトJIS）
        Dim str As String
        Dim bytesData As Byte()

        'DOC_INFO_1を設定する
        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'プリンタオープン
        name = TextBox2.Text
        Ret = OpenPrinter(name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        '印字処理スタート
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'コマンド送信（初期化）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'コマンド送信（シフトJIS指定コマンド FS C 1）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "****** CODE39 TEST ******" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（バーコードHRI文字指定）
        cmd(0) = &H1D
        cmd(1) = &H48
        cmd(2) = &H2
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（バーコード高さ指定）
        cmd(0) = &H1D
        cmd(1) = &H68
        cmd(2) = &H64
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（バーコード幅指定）
        cmd(0) = &H1D
        cmd(1) = &H77
        cmd(2) = &H2
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（CODE39）
        cmd(0) = &H1D
        cmd(1) = &H6B
        cmd(2) = &H4
        WritePrinter(hPrinter, cmd, 3, Written)

        'バーコードデータ
        str = "ABCDEF"
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'NULL(0x00)コード送信
        cmd(0) = &H0
        WritePrinter(hPrinter, cmd, 1, Written)

        'コマンド送信（紙送りコマンド）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '印字処理終了
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'プリンタクローズ
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'QRコード印刷

        'プリンタドライバ名称
        Dim name As String
        'プリンタハンドル
        Dim hPrinter As Integer
        'APIのリターン値
        Dim Ret As Integer
        'DOC_INFO_1（RAWデータの指定に使用）
        Dim di As New DOC_INFO_1
        '送信したバイト数
        Dim Written As Integer

        'プリンタコマンド用配列
        Dim cmd As Byte() = New Byte(16) {}

        '文字列変換（シフトJIS）
        Dim str As String
        Dim bytesData As Byte()

        'DOC_INFO_1を設定する
        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'プリンタオープン
        Name = TextBox2.Text
        Ret = OpenPrinter(Name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        '印字処理スタート
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'コマンド送信（初期化）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'コマンド送信（シフトJIS指定コマンド FS C 1）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "****** QR CODE TEST ******" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（QRコード）
        cmd(0) = &H1D
        cmd(1) = &H51
        cmd(2) = &H6
        cmd(3) = &H4
        cmd(4) = &H4
        cmd(5) = &H14
        cmd(6) = &H0
        WritePrinter(hPrinter, cmd, 7, Written)

        'QRコードデータ
        str = "QRCODE TEST123456789"
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)


        'コマンド送信（紙送りコマンド）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '印字処理終了
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'プリンタクローズ
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        '領収書サンプル

        'プリンタドライバ名称
        Dim name As String
        'プリンタハンドル
        Dim hPrinter As Integer
        'APIのリターン値
        Dim Ret As Integer
        'DOC_INFO_1（RAWデータの指定に使用）
        Dim di As New DOC_INFO_1
        '送信したバイト数
        Dim Written As Integer

        'プリンタコマンド用配列
        Dim cmd As Byte() = New Byte(16) {}

        '文字列変換（シフトJIS）
        Dim str As String
        Dim bytesData As Byte()

        'DOC_INFO_1を設定する
        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'プリンタオープン
        Name = TextBox2.Text
        Ret = OpenPrinter(Name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        '印字処理スタート
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'コマンド送信（初期化）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'コマンド送信（シフトJIS指定コマンド FS C 1）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（印字位置中央合わせコマンド）
        cmd(0) = &H1B
        cmd(1) = &H61
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（全角文字4倍角指定コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H8
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "［クレジット売上票］" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（印字位置左合わせコマンド）
        cmd(0) = &H1B
        cmd(1) = &H61
        cmd(2) = &H0
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（全角文字4倍角解除コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H0
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "加盟店名  ○○○○株式会社" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "          TEL:XX-XXXX-XXXX" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "ご利用日　  20XX/XX/XX (月)13:00" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "カード番号　XXXXXXXXXXXX0000(IC)" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "支払い区分　一括" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字4倍角指定コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H8
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "合計金額　　　　　￥２９，８００" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字4倍角解除コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H0
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "SANEI TAROU" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "ご利用ありがとうございました" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "またのご来店をお待ちしております" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "売場：　　　　　係員：" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "--------------------------------" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字アンダーライン指定コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "サイン欄：　　　　　　　　　　　" & vbLf & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字アンダーライン解除コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H0
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "［お客様控え］" & vbLf & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字アンダーライン指定コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '文字列送信
        str = "＊これはデモサンプル印字です。" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        '文字列送信
        str = "＊本物の領収書ではございません。" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'コマンド送信（全角文字アンダーライン解除コマンド）
        cmd(0) = &H1C
        cmd(1) = &H21
        cmd(2) = &H0
        WritePrinter(hPrinter, cmd, 3, Written)

        'コマンド送信（紙送りコマンド）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        '印字処理終了
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'プリンタクローズ
        ClosePrinter(hPrinter)

    End Sub
End Class
